(function($) {

  var $event = $.event,
    $special,
    resizeTimeout;

  $special = $event.special.debouncedresize = {
    setup: function() {
      $( this ).on( "resize", $special.handler );
    },
    teardown: function() {
      $( this ).off( "resize", $special.handler );
    },
    handler: function( event, execAsap ) {
      // Save the context
      var context = this,
        args = arguments,
        dispatch = function() {
          // set correct event type
          event.type = "debouncedresize";
          $event.dispatch.apply( context, args );
        };

      if ( resizeTimeout ) {
        clearTimeout( resizeTimeout );
      }

      execAsap ? dispatch() : resizeTimeout = setTimeout( dispatch, $special.threshold );
    },
    threshold: 150
  };

})(jQuery);




var curSlide;
window.unionSwipe = Swipe(document.getElementById('slider'), {
  continuous: false,
  transitionEnd: function(i, e){
    curSlide = $(e);
    $('#slider').height(curSlide.height());
    window.scrollTo(0,0);
  }
});

$(document).ready(function(){
  $('.category-item').hammer().on('click tap', function(e){
    e.preventDefault();
    slide = $(this).data('slide');
    unionSwipe.slide(slide,300);
  });

  $('.back-button').hammer().on('click tap', function(e){
    e.preventDefault();
    unionSwipe.slide(0,300);
  });

  $('.open-modal').hammer().on('click tap', function(e){
    src = $(this).data('src');
    $('#modal-image').attr('src', src);
    $('#modal-wrapper').fadeIn();

    e.preventDefault();
  });

  $('.close-modal').hammer().on('click tap', function(e){
    $('#modal-wrapper').fadeOut();

    e.preventDefault();
  });


  $('.product-list').each(function(i,e){
    $(e).freetile();
  });

  $('#slider').height($('.categories-wrapper').height());

  window.applicationCache.addEventListener('updateready', function(e) {
    window.applicationCache.swapCache();
    if (confirm('Carregar nova versão do Catálogo?')) {
      window.location.reload();
    }
  });

  window.applicationCache.addEventListener("downloading", function(e) {
    console.log("Downloading resources...");
  });

  window.applicationCache.addEventListener("cached", function(e) {
    console.log("Resources are cached");
  });

});

$(window).on('debouncedresize', function(e){
  if (curSlide){
    setTimeout(function(){
      $('#slider').height(curSlide.height());
    },300);
  } else {
    $('#slider').height($('.categories-wrapper').height());
  }
});